#!/bin/bash
# Name: <bert2002>
# Homepage: http://www.pissflitsche.net/kernelscript
# Datum: 21.04.2006
version=0.3.9
clear
if [ `id -un` != root ] 
	then 
		dialog --title "root access requirement" --backtitle "kernelscript $version" --msgbox "       Please start the script as root" 5 50
		exit 0
fi


function start {
	echo "Please wait a few seconds. Check kernel versions... [ONLINE]"
	rm -rf ~/.kernelscript/ 2> /dev/null
	mkdir ~/.kernelscript/ 2> /dev/null
	touch ~/.kernelscript/vpatch && touch ~/.kernelscript/vkernel && touch ~/.kernelscript/vback
	cd ~/.kernelscript/ && wget http://www.kernel.org/kdist/finger_banner 2> /dev/null
	cat finger_banner | grep "The latest stable version of the Linux kernel is" | cut -b 61-68 > stable26
	cat finger_banner | grep "The latest 2.4 version of the Linux kernel is:" | cut -b 61-66 > stable24 
	unset stable26 stable24
	stable26=`cat stable26`
	stable24=`cat stable24`
	if [ -s ~/.kernelscript/stable26 ] 2>/dev/null; then echo "New Release..."; else echo "Internet not awnser?" && exit 1; fi
	clear
	########## update-grub
	if [ -e ~/.kernelscript/update-grub ] 2>/dev/null; then
		echo "update grub script: Okay"
	else
		echo -n "download update grub script: "
		cd ~/.kernelscript 2>/dev/null
		wget --tries=10 http://www.pissflitsche.net/kernelscript/update-grub  && echo "Okay" 2>/dev/null
		chmod +x update-grub
	fi
	########## Which kernel
	dialog --backtitle "kernelscript $version" --checklist "Please choose one kernel:" 0 0 0 "$stable26" "The latest 2.6 version" On  "$stable24" "The latest 2.4 version" Off 2> ~/.kernelscript/vkernel
	if [ $? == 1 ]; then exit 0; fi
	
	dialog --backtitle "kernelscript $version" --checklist "What will we do?" 0 0 0 "NewConfig" "Create a new kernel Config" On "OldConfig" "Use a old config" Off 2> ~/.kernelscript/vback
	if [ $? == 1 ]; then exit 0; fi

	########## new or old config
	if [ `cat ~/.kernelscript/vback` == "\"NewConfig\"" ] 2>/dev/null ; then
		back=menuconfig
	else
		back=oldconfig
		if [ -d /usr/src/linux ] 2>/dev/null; then
			cp /usr/src/linux/.config "/usr/src/config-`uname -r`"
		else
			dialog --title "Config file" --backtitle "kernelscript $version" --inputbox "Whereis is the config file?" 10 50  2> ~/.kernelscript/.kconfig
		cp `cat ~/.kernelscript/.kconfig` "/usr/src/config-`uname -r`"
		fi
	fi
	##########
}


function stable {
	mkdir /usr/src 2> /dev/null
	rm /usr/src/linux-$stable26.tar.gz 2>/dev/null
	rm -rf /usr/src/linux-$stable26/ 2>/dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.6/linux-$stable26.tar.gz
	clear
	echo "Kernel becomes now unpacked!"
	tar -xvzf linux-$stable26.tar.gz && rm ./linux
	ln -s /usr/src/linux-$stable26 /usr/src/linux
	cd /usr/src/linux/
	if [ $back == "oldconfig" ] 2>/dev/null; then
		cp "/usr/src/config-`uname -r`" .config
		make $back
	else
		make $back
	fi
	make all && make modules_install || echo "compile error"
	cp ./System.map /boot/System.map-$stable26  || exit 1
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-$stable26 &
	mkinitrd /boot/initrd-$stable26 $stable26 || mkinitrd || mk_initrd
	clear
	dialog --title "Kernel ready to boot" --backtitle "kernelscript $version" --no-label "Exit" --yesno "Kernel: /boot/vmlinuz-$stable26\nSystem: /boot/System.map-$stable26\nNow you must only insert the new kernel in your bootloader.\nDo you want add it to your Grub Config?" 8 65
	if [ $? == 0 ]; then
	sh ~/.kernelscript/update-grub
	fi
	exit 0
}




function stablezwo {
	clear
	mkdir /usr/src 2> /dev/null
	rm /usr/src/linux-$stable24.tar.gz 2>/dev/null
	rm -rf /usr/src/linux-$stable24/ 2>/dev/null
	cd /usr/src/ && wget ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-$stable24.tar.gz || wget -c ftp://ftp.kernel.org/pub/linux/kernel/v2.4/linux-$stable24.tar.gz
	clear
	echo "Kernel becomes now unpacked!"
	tar -xzf linux-$stable24.tar.gz && rm ./linux
	ln -s ./linux-$stable24 ./linux
	cd /usr/src/linux/ 
	if [ $back == "oldconfig" ] 2>/dev/null; then
		cp "/usr/src/config-`uname -r`" .config
		make $back
	else
		make $back
	fi
	make dep clean bzImage || echo "kernel compile error"
	make modules || echo "module compile error"
	make modules_install || echo "modules_install error"
	rm -rf /boot/System.map-$stable24 & 2> /dev/null
	rm -rf /boot/vmlinuz-$stable24 & 2> /dev/null
	cp ./System.map /boot/System.map-$stable24 || exit 1
	cp ./arch/i386/boot/bzImage /boot/vmlinuz-$stable24 &
	mkinitrd /boot/initrd-$stable24 $stable24 || mkinitrd || mk_initrd
	clear
	dialog --title "Kernel ready to boot" --backtitle "kernelscript $version" --no-label "Exit" --yesno "Kernel: /boot/vmlinuz-$stable24\nSystem: /boot/System.map-$stable24\nNow you must only insert the new kernel in your bootloader.\nDo you want add it to your Grub Config?" 8 65
	if [ $? == 0 ]; then
	sh ~/.kernelscript/update-grub
	fi
	exit 0
}



#letz start
start
if [ `cat ~/.kernelscript/vkernel` == "\"$stable26\"" ] 2>/dev/null ; then
	stable
else
	if [ `cat ~/.kernelscript/vkernel` == "\"$stable24\"" ] 2>/dev/null ; then
		stablezwo
	fi
fi
exit 0
